from pydantic import BaseModel
from typing import Optional
import yaml


class Service(BaseModel):
    name: Optional[str] = None
    version: Optional[str] = None
    application: Optional[str] = None
    domain: Optional[str] = None
    namespace: Optional[str] = None
    agent: Optional[dict] = None
    dependencies: Optional[list] = None
    provider_dependencies: Optional[list] = None
    endpoints: Optional[list] = None
    spec: Optional[dict] = None


def load_service_configuration(d: Optional[str] = ".") -> Optional[Service]:
    """Load the service configuration from the service.codefly.yaml file"""
    path = f"{d}/service.codefly.yaml"
    with open(path, 'r') as f:
        return Service(**yaml.safe_load(f))

